/* Teil von RandomXmas v1.13 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original 
 * hiervon und Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include <GL/glut.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <stdlib.h>
#include <stdio.h>

#include "ebenefeld.h"

//---Klasse Feld-----------------------------------------

Feld::Feld(feldtyp neutyp, int neuhoehe, int neudarunter,
		int neudarueber, Texture* neuthistex)
{
  texfeld = neuthistex;
  this->typ = neutyp;
  this->hoehe = neuhoehe;
  this->darunter = neudarunter;
  this->darueber = new GrafikAusgabe(0, 0, 0, neudarueber);
  this->darueber->SetSize(MAXFELD/3);
  this->textoben[1] = '\0';
  this->textoben[0] = (neudarueber % 26) + 64;
  this->darueber->SetText( textoben );
  this->darueber->SetColor(C_CHARS_ABOVE[0], C_CHARS_ABOVE[1], 
				C_CHARS_ABOVE[2]);
  qfeld = NULL;
  qfeld = gluNewQuadric();
}

Feld::~Feld()
{
  this->typ = typlos;
  this->hoehe = 0;
  this->darunter = 0;
  delete darueber;
  texfeld = NULL;
  if (qfeld) gluDeleteQuadric(qfeld);
};

void Feld::Invisible(short onoff)
{
  if (onoff == 0) gluDeleteQuadric(qfeld);
  qfeld = NULL;
  if (onoff == 1) qfeld = gluNewQuadric();
}

void Feld::Change(feldtyp neutyp, int neuhoehe, int neudarunter)
{
  this->typ = neutyp;
  if (neuhoehe > 0) this->hoehe = neuhoehe;
  this->darunter = neudarunter;
}

int Feld::Leeren()
{
  int erg;

  erg = this->darunter;
  this->darunter = 0;
  if (this->typ == huegel)
    if (this->hoehe <= MAXFELDHOEHE/2)
      erg = 0;			//Huegel zu klein
  return erg;
};

int Feld::GetDarueber()
{
  int x, erg=0;

  x = this->darueber->GetWert();
  if  (x <= 2) erg = erg + 500;
  if ((x >= 2) && (x < 3)) erg = erg + 99;
  if ((x >= 3) && (x < 4)) erg = erg + 22;
  if ((x >= 4) && (x < 5)) erg = erg + 44;
  if ((x >= 5) && (x < 6)) erg = erg + 22;
  if  (x >= 5) erg = erg + 2000;
  if  (x ==  0) erg = 0;
  this->darueber->SetWert(0);
  this->darueber->SetText(" ");
  return erg;
};

feldtyp Feld::GetTyp()
{
  return this->typ;
}

void Feld::DrawFeld(int x, int y, GLuint displaylist)
{
  int bedingung;
  float verschiebung;

  glNewList(displaylist, GL_COMPILE);	// bis zum Ende
  bedingung = (this->typ == baum)*4 + (this->typ == huegel)*2;
  bedingung = bedingung + ((this->darunter == 0) && (EINFACH > 0));  // % 2

  if ((texfeld) && (bedingung % 2 == 0)) 
	glBindTexture(GL_TEXTURE_2D, texfeld->GetTexNumber() );
  glTranslatef(x*2, -y*2, 0);	//y -> z

  if (bedingung >= 4)			// baum
    { 
      glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, BAUM_AMB);
      if (bedingung % 2)
	  { 
		glColor3fv(C_BAUM_1);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, BAUM_DIF1);
	  }
        else
	  {
		glColor3fv(C_BAUM_2);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, BAUM_DIF2);
	  };
    };
  if (bedingung & 2)			// huegel
    {    
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, HUEGEL_SPEC);
	if (bedingung % 2)
	    {
		glColor3fv(C_HUEGEL_1);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, HUEGEL_AMB1);
	    }
      	  else
	    {
		glColor3fv(C_HUEGEL_2);
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, HUEGEL_AMB2);
	    };
    };
  verschiebung = (this->hoehe - 1) * FELDEINHEIT;
  if (bedingung > 1)			// Baum oder Huegel
    if (hoehe < 4)
      gluCylinder(qfeld, 0.6, 0.4, verschiebung, DETAILS, DETAILS/2);
    else
      gluCylinder(qfeld, 1, 0.4, verschiebung, DETAILS, DETAILS/2);

  glTranslatef(0, 0, verschiebung);
  if (bedingung & 2) gluSphere(qfeld, 0.4, DETAILS, DETAILS);
  if (bedingung >= 4) gluCylinder(qfeld, 0.4, 0, 2*FELDEINHEIT, DETAILS, DETAILS/2);
  glTranslatef(0, 0, -verschiebung);
  if (texfeld) glBindTexture(GL_TEXTURE_2D, 0);

  if (bedingung >= 4) 
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, MATERIAL_NULL);
  if (bedingung & 2) 
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, MATERIAL_NULL);
  if (darueber->GetWert() )
    {
	verschiebung = (MAXFELDHOEHE + 3) * FELDEINHEIT;
	glTranslatef(0, 0, verschiebung);
	glRotatef(90, 1, 0, 0);
	darueber->DrawAusgabe();
	glRotatef(-90, 1, 0, 0);
	glTranslatef(0, 0, -verschiebung);
    };
  glTranslatef(-x*2, y*2, 0);
  glEndList();
};

//---Klasse Ebene-------------------------------------

Ebene::Ebene(int neunummer, Texture* *neutexarray)
{
  int x, y;

  texarray = neutexarray;
  InitFelder(neunummer);  
  fahrstuhl=0;  

  nummer = new GrafikAusgabe( 2/1.0f, -2.25, 0, neunummer);
  nummer->SetSize(0.7f);
  nummer->SetColor(C_NUMMER[0], C_NUMMER[1], C_NUMMER[2]);

  zeile = new GrafikAusgabe( 0, -2.25, 0, 0);
  if (USE_GLUT_FONT) zeile->SetSize(0.7f);
   else 	     zeile->SetSize(0.5f);
  zeile->SetText("Ebene");
  zeile->SetColor(C_ZEILE[0], C_ZEILE[1], C_ZEILE[2]);

  startList = glGenLists(MAXFELD*MAXFELD + 1);
  DrawGround(startList);
  for(y=0; y<=MAXFELD-1; y++)
    for(x=0; x<=MAXFELD-1; x++)
      this->felder[x][y]->DrawFeld(x*2+1-MAXFELD, y*2+1-MAXFELD,
				 	startList + y*MAXFELD + x + 1);
}

Ebene::~Ebene()
{
  int x,y;

  texarray = NULL;
  if (glIsList(startList)) glDeleteLists(startList, MAXFELD*MAXFELD+1);
  for(y=0; y<=MAXFELD-1; y++)
    for(x=0; x<=MAXFELD-1; x++)
      delete this->felder[x][y];
  delete nummer;
  delete zeile;
}

void Ebene::InitFelder(int neunummer)
{
  int 	  x,y, neuhoehe, anzunten, anzoben, r1, r2;
  feldtyp neutyp;
  struct timeval  tv;
  struct timezone tz;

  gettimeofday(&tv, &tz);			//init Zufallsgenerator
  srand(tv.tv_sec % 65536);

  for(y=0; y<=MAXFELD-1; y++)			
    for(x=0; x<=MAXFELD-1; x++)
      {
	r1 = rand()% 3; r2 = rand() % 3;
	if (r1 == 0) neutyp = huegel;
	        else neutyp = baum;
	r1 = (rand() % MAXFELDHOEHE/2)+1;
	if (neutyp == baum) neuhoehe = r1*2;
	   else if (r2 == 0) neuhoehe = r1;
	          else neuhoehe = MAXFELDHOEHE/2 + r1;
	r1 = (rand() % MAXFELDHOEHE);
	r2 = (rand() % MAXFELDHOEHE);
	anzunten = (r1*10 + r2);
	r1 = rand() % (MAXFELD*MAXFELD);
	r2 = rand() % 7;
	if (r1 < MAXFELD) anzoben = r2; else anzoben=0;
	if (y*MAXFELD + x == neunummer % ( MAXFELD*MAXFELD) ) 
	  anzunten = anzunten + 2000;
        if (neutyp == huegel) anzunten = anzunten % (MAXEBENEN-1);
	if (neutyp == huegel)
	  this->felder[x][y] = new Feld(neutyp, neuhoehe, anzunten, 
					anzoben, texarray[1]);
	if (neutyp == baum)
	  this->felder[x][y] = new Feld(neutyp, neuhoehe, anzunten, 
					anzoben, texarray[2]);
      };
};

int Ebene::IstDortBaum(int x, int y)
{
  feldtyp thistyp;
  int bedingung, feldx, feldy, erg=-1;	//0-99:Baum mit Geschenkanz,
					// -1: leer, -2..-101: Huegel

  bedingung = ( (abs(x % 2) != (MAXFELD % 2)) && (abs(y % 2) != (MAXFELD % 2)) );
  if (bedingung)  			//sonst kein EbenenFeld dort
    { 
      feldx = (x-1+MAXFELD)/2;   	//siehe auch DrawEbene
      feldy = (y-1+MAXFELD)/2;
      if ((feldx >= 0) && (feldx < MAXFELD))
        if ((feldy >= 0) && (feldy < MAXFELD))
	  {
		thistyp = this->felder[feldx][feldy]->GetTyp();
		if (thistyp == baum)
		  erg = felder[feldx][feldy]->Leeren();
		if (thistyp == huegel)
		  erg = -((felder[feldx][feldy]->Leeren()) + 2);
		if ((thistyp == baum) || (thistyp == huegel))
		  felder[feldx][feldy]->DrawFeld(feldx*2+1-MAXFELD, feldy*2+1-MAXFELD,
					startList + feldy*MAXFELD+feldx + 1);
    	  };
    };
  return erg;
}

int Ebene::GetDarueber(int x, int y)
{
  int bedingung, feldx, feldy, erg= 0;

  bedingung = ( (abs(x % 2) != (MAXFELD % 2)) && (abs(y % 2) != (MAXFELD % 2)) );
  if (bedingung)			//sonst kein EbenenFeld dort
    {
	feldx = (x-1+MAXFELD)/2;
	feldy = (y-1+MAXFELD)/2;
        if ((feldx >= 0) && (feldx < MAXFELD))
          if ((feldy >= 0) && (feldy < MAXFELD))
	    {
		erg = this->felder[feldx][feldy]->GetDarueber();
		felder[feldx][feldy]->DrawFeld(feldx*2+1-MAXFELD, feldy*2+1-MAXFELD,
				startList + feldy*MAXFELD+feldx + 1);
	    };
    };	
  return erg;
};

void Ebene::TrigFahrstuhl()
{
  int x, y;

  if (this->fahrstuhl == 1) this->fahrstuhl=0;
    else this->fahrstuhl=1;
  if (this->fahrstuhl == 1)
	glDeleteLists(startList, MAXFELD*MAXFELD+1);	// save mem
    else
      {
	startList = glGenLists(MAXFELD*MAXFELD+1);
	DrawGround(startList);
      };
  for(y=0; y<=MAXFELD-1; y++)
    for(x=0; x<=MAXFELD-1; x++)
      if (fahrstuhl == 1)
		felder[x][y]->Invisible(0);
      else 
	{
		felder[x][y]->Invisible(1);
		felder[x][y]->DrawFeld(x*2+1-MAXFELD, y*2+1-MAXFELD,
					startList + y*MAXFELD + x + 1);
	};
}

void Ebene::DrawGround(GLuint displayList)
{
  int s;

  glNewList(displayList, GL_COMPILE);
  s=MAXFELD*2+1;
  if (texarray[0]) 
    glBindTexture(GL_TEXTURE_2D, texarray[0]->GetTexNumber() );
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);                                                     
  glColor3fv(C_GROUND);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, EBENE_AMB);
  glBegin(GL_QUADS);
    glTexCoord2f(0.0, 0.0); glVertex3f(-s, 0, -s);
    glTexCoord2f(0.0,   s); glVertex3f(-s, 0,  s);
    glTexCoord2f(  s,   s); glVertex3f( s, 0,  s);
    glTexCoord2f(  s, 0.0); glVertex3f( s, 0, -s);
  glEnd();
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);                                                     
  if (texarray[0]) glBindTexture(GL_TEXTURE_2D, 0);
  glEndList();
};

void Ebene::DrawEbene()
{
  int x,y;

  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, EBENE_AMB);
  glPushMatrix();

  glCallList(startList);

  glRotatef(270, 1, 0, 0);
  if (this->fahrstuhl == 0)
    for(y=0; y<=MAXFELD-1; y++)
      for(x=0; x<=MAXFELD-1; x++)
         glCallList(startList + y*MAXFELD + x + 1);
  glRotatef(90, 1, 0, 0);

  glPopMatrix();
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, MATERIAL_NULL);
};

void Ebene::DrawLevelNum()
{
  nummer->DrawAusgabe();
  zeile->DrawAusgabe();
};

