/* RandomXmas v1.13 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include <sys/time.h>
#include <sys/timeb.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "highsboard.h"
#include "konstanten.h"

Highscoreboard::Highscoreboard(int getpoints, char *full_name, char *highscorefile)
{
   int i;
   struct timeb tp;
   char zeit[24];

   imax = 0;
   scorepagelist = NULL;
   points = getpoints;
   highsfile = highscorefile;
   for(i=0; i<linesize; i++) pointsstring[i] = ' ';
   for(i=0; i<pagesize+3; i++) 
     {
	topten[i] = new GrafikAusgabe(-4*MAXFELD, MAXFELD/2*(8 - i), -5*MAXFELD/2, 0);
	topten[i]->SetSize(MAXFELD/3);
	topten[i]->SetColor(C_BOARD[0], C_BOARD[1], C_BOARD[2]);
	topten[i]->SetText("");
     };
   sprintf(pointsstring, "%d ", points);
   i=ftime(&tp);
   strncpy(zeit, ctime(&tp.time), strlen(ctime(&tp.time)) + 1 );
   strncat(pointsstring, zeit, strlen(zeit) - 1);
   strcat(pointsstring, " ");
   if (full_name) strcat(pointsstring, full_name);

   Readfile();
   pagenow = scorepagelist;
   LoadPage();
};

   
Highscoreboard::~Highscoreboard()
{
   int i;

   Writefile();
   delete scorepagelist;
   for(i=0;i<  12;i++) delete topten[i];
};

void Highscoreboard::Scroll(int numofpages)
{
   Doublelist *following;

   following = NULL;
   if (numofpages < 0)
     while (numofpages < 0)
       {
		if (pagenow) pagenow->GetPrev(following);
		if (following) pagenow = following;
		  else	       numofpages = -1;			// break loop
		numofpages++;
       };
   if (numofpages > 0)
     while (numofpages > 0)
       {
		if (pagenow) pagenow->GetNext(following);
		if (following) pagenow = following;
		  else	       numofpages = +1;			// break loop
		numofpages--;
       };
   LoadPage();
};

void Highscoreboard::CloseSublist(Stringlist* &pagebegin, Stringlist* &pageend,
				Doublelist* &lastpage)
{
   if (scorepagelist) 
  	scorepagelist->InsLast(lastpage, pagebegin, pageend);
     else {
		scorepagelist = new Doublelist(pagebegin, pageend);
		lastpage = scorepagelist;
	  };
   pagebegin = NULL; pageend = NULL;
};

void Highscoreboard::Readfile()
{
   int	i=0;
   FILE *fpr;
   char zeile[linesize], *thisline;
   Stringlist *pagebegin, *pageend, *scorelist, *scorelistlast;
   Doublelist *lastpage;

   pagebegin = NULL; pageend = NULL; scorelist = NULL; scorelistlast = NULL;
   lastpage = NULL;
   if (highsfile) fpr = fopen(highsfile, "r");
     else fpr = NULL;
   if (fpr) 
     {
	rewind(fpr);
	i = 0;
	if (fpr) 
          while (fgets(zeile, linesize, fpr))
           {
		thisline = new char[ strlen(zeile) + 1 ];
		strcpy(thisline, zeile);
		if (i == 0) 
		  { 
			scorelist = new Stringlist(thisline);
			scorelistlast = scorelist;
		  }
		  else scorelist->InsLast(scorelistlast, thisline);
		if ((i % pagesize) == 0) 
		  pagebegin = scorelistlast;
		if ((i % pagesize) == pagesize - 1)
		  {
			pageend = scorelistlast;
			CloseSublist(pagebegin, pageend, lastpage);
		  };
		i = i + 1;
	  	imax = i;
           }
	if (pagebegin)		// save rest in list
	  CloseSublist(pagebegin, pageend, lastpage);
	fclose(fpr);
     }
};

void Highscoreboard::LoadPage()
{
   int i = 0;
   char *zeile;
   Simplelist *begin = NULL;
   Stringlist *pagebegin = NULL, *aidnext = NULL;

   zeile = new char[linesize];
   if (pagenow) pagenow->GetValue(i);
     else	      i = 0;
   sprintf(zeile, "Highscore: Plaetze %d-%d", i * pagesize + 1, (i+1) * pagesize);   
   topten[0]->SetText(zeile);
   i = 0;
   if (pagenow) pagenow->GetBegin(begin);
   if (begin) pagebegin = (Stringlist *) begin;
   while (i < pagesize)
     {
	if (pagebegin) 
	  {
		pagebegin->GetText(zeile);		// Read line
		topten[i+1]->SetText(zeile);		// insert in showtable
		pagebegin->GetNext(aidnext);		// go to next
		pagebegin = aidnext;
	  }
	  else topten[i+1]->SetText("");
	i = i + 1;
     }
   topten[pagesize+1]->SetText("Deine Punkte");
   topten[pagesize+2]->SetText(pointsstring);
};

void Highscoreboard::GetListLine(Stringlist* &scorenow, char* &zeile)
{
   Stringlist *aidnext = NULL;

   zeile = NULL;
   if (scorenow)
     {
	scorenow->GetText(zeile);			// Read line
	scorenow->GetNext(aidnext);			// Go to next
	scorenow = aidnext;
     };
};

void Highscoreboard::Writefile()
{
   int	i=0, highpunkte;
   FILE *fpr;
   char *zeile;
   Simplelist *begin = NULL;
   Stringlist *scorenow = NULL;

   i=0;
   fpr = fopen(highsfile, "w");
   if (fpr)
     {
	if (scorepagelist) scorepagelist->GetBegin(begin);		// first line
	if (begin) scorenow = (Stringlist*) begin;
	GetListLine(scorenow, zeile);
	if (imax > 0) highpunkte = strtol(zeile, (char **)NULL, 10);
	  else highpunkte = -2;
   	i=0;
   	while ( (highpunkte > points) && (i < imax) )
     	  {
		fprintf(fpr, zeile);
		GetListLine(scorenow, zeile);
		if (zeile) highpunkte = atoi(zeile);
		  else	   highpunkte = -2; 	
     	  };
   	fprintf(fpr, pointsstring);
   	fprintf(fpr, "\r\n");		//Dos-Kompatibel
   	while (i < imax) 
     	  {
		fprintf(fpr, zeile);
		GetListLine(scorenow, zeile);
		if (!zeile) i = imax;
     	  }	
   	fclose(fpr);
     }
    else 
     { 
	printf(pointsstring);
	printf("\r\n");			//Dos-Kompatibel
     } 
};

void Highscoreboard::DrawBoard()
{
   int i;

   for(i=0; i < pagesize+3; i++)
	if (topten[i]) topten[i]->DrawAusgabe();
};


