/* RandomXmas v1.13 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#ifndef _LISTEN_H
#define _LISTEN_H 1

#include <stdio.h>				// needed for NULL

typedef		int	Valuetype;		// should be a number
typedef		char*	Texttype;

class Simplelist
  {
	protected:
		Valuetype	value;
		Simplelist	*next;
	public:
		Simplelist(Valuetype newvalue) : value(newvalue), next(NULL) {};
		~Simplelist();
		void InsLast(Simplelist* &last, Valuetype newvalue);
		void InsFirst(Valuetype newvalue); 		// Inserthere
		int  DelFirst();
		int  DelNext();
		void FindValue(Valuetype newvalue, Simplelist* &newlist);
							// return one before to make DelNext

		void GetNext(Simplelist* &thisnext);
		void SetNext(Simplelist* newnext);
		void GetValue(Valuetype &thisvalue);
		void SetValue(Valuetype newvalue);
  };

class Stringlist : public Simplelist
  {
	protected:
		Texttype	textstring;
		Stringlist	*next;
	public:
		Stringlist(Texttype newtext) : 
			Simplelist(0), textstring(newtext), next(NULL) {;};
		~Stringlist();
		void InsLast(Stringlist* &last, Texttype newtext);
		void InsFirst(Texttype newtext);
		int  DelFirst();
		int  DelNext();
		void FindText(Texttype newtext, Stringlist* &newlist);
		void FindValue(Valuetype newvalue, Stringlist* &newlist);
							// return one before to make DelNext

		void GetText(Texttype &thistext);
		void SetText(Texttype newtext);
		void GetNext(Stringlist* &thisnext);
		void SetNext(Stringlist* newnext);
  };

class Doublelist : public Simplelist
  {
	protected:
		Simplelist	*subbegin, *subend;
		Doublelist	*prev, *next;
	public:
		Doublelist(Simplelist *neubegin, Simplelist *neuend) : 
			Simplelist(0), subbegin(neubegin), subend(neuend),
			prev(NULL), next(NULL) {;};
		~Doublelist();	
		void InsLast(Doublelist* &last, 
				Simplelist *newbegin, Simplelist *newend);
		void InsFirst(Simplelist *newbegin, Simplelist *newend);
		int  DelFirst();
		int  DelNext();
		void FindBegin(Simplelist* newbegin, Doublelist* &newlist);
		void FindEnd(Simplelist* newend, Doublelist* &newlist);
		void FindValue(Valuetype newvalue, Doublelist* &newlist);
							// return one before to make DelNext

		void GetBegin(Simplelist* &thisbegin);
		void GetEnd(Simplelist* &thisend);
		void SetBegin(Simplelist* newbegin);
		void SetEnd(Simplelist* newend);
		void GetPrev(Doublelist* &thisprev);
		void SetPrev(Doublelist* newprev);
		void GetNext(Doublelist* &thisnext);
		void SetNext(Doublelist* newnext);
  };

#endif

