/* RandomXmas v1.13 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

// Test program for class listen
// g++ -g -c listen.cpp -o listen.o
// g++ -g -c listencheck.cpp -o listencheck.o
// g++ -o listencheck listen.o listencheck.o

#include <string.h>
#include "listen.h"

void showsimplelist(Simplelist *list)
{  
   int value;
   Simplelist *aidnext;

   printf("List: ");
   while (list != NULL)				// while exist a list
     {
	list->GetValue(value);			
	printf("%d ", value);			// print value
	list->GetNext(aidnext);			// Goto next
	list = aidnext;
     };
   printf("\n");
};

void testsimplelist()
{
   int i;
   Simplelist *head, *last;

   head = new Simplelist(0);
   last = head;
   
   printf("InsLast\n"); 
   for(i=1; i<=10; i++)
     head->InsLast(last, i);
   showsimplelist(head);
   printf("InsFirst\n"); 
   head->InsFirst(i);
   showsimplelist(head);
   printf("Delnext on head\n"); 
   head->DelNext();
   showsimplelist(head);
   printf("Delfirst on head\n"); 
   head->DelFirst();
   showsimplelist(head);

   printf("Delnext on last\n"); 
   last->DelNext();
   showsimplelist(head);
   printf("Delfirst on last\n"); 
   last->DelFirst();
   showsimplelist(head);
   printf("Delete last with FindValue of last\n");
   last->GetValue(i);
   head->FindValue(i, last);
   last->DelNext();
   showsimplelist(head);
   printf("Findvalue+DelNext\n"); 
   head->FindValue(5, last);
   last->DelNext();
   showsimplelist(head);
   printf("Find first value (1) and show empty result\n");
   head->FindValue(1, last);
   showsimplelist(last);
   printf("Find not used value (12) and show empty result\n");
   head->FindValue(12, last);
   showsimplelist(last);
   printf("Delete\n"); 
   delete head;
   showsimplelist(head);
};

void showstringlist(Stringlist *list)
{  
   int value;
   char *text;
   Stringlist *aidnext;

   printf("List: ");
   while (list != NULL)				// while exist a list
     {
	list->GetText(text);
	list->GetValue(value);			
	printf("\"");
	printf(text);				// print content
	printf("\"");
	printf(" %d ", value);
	list->GetNext(aidnext);			// Goto next
	list = aidnext;
     };
   printf("\n");
};

void teststringlist()
{
   int i;
   char *text;
   Stringlist *head, *last;
   
   text = new char[5];
   sprintf(text, "%d", 0);
   head = new Stringlist(text);
   last = head;

   printf("Inslast\n");
   for(i=1; i<=10; i++)
     {
	text = new char[5];
   	sprintf(text, "%d", i);
	head->InsLast(last, text);
     };
   showstringlist(head);
   printf("InsFirst\n"); 
   text = new char[5];
   sprintf(text, "%d", i);
   head->InsFirst(text);
   showstringlist(head);
   printf("Delnext on head\n"); 
   head->DelNext();
   showstringlist(head);
   printf("Delfirst on head\n"); 
   head->DelFirst();
   showstringlist(head);

   printf("Delnext on last\n"); 
   last->DelNext();
   showstringlist(head);
   printf("Delfirst on last\n"); 
   last->DelFirst();
   showstringlist(head);
   printf("Delete last with FindText of last\n");
   last->GetText(text);
   head->FindText(text, last);
   last->DelNext();
   showstringlist(head);
   printf("FindText+DelNext\n"); 
   head->FindText("5", last);
   last->DelNext();
   showstringlist(head);
   printf("Find first Text (\"1\") and show empty result\n");
   head->FindText("1", last);
   showstringlist(last);
   printf("Find not used Text (\"12\") and show empty result\n");
   head->FindText("12", last);
   showstringlist(last);
   printf("Delete\n"); 
   delete head;
   showstringlist(head);
};

void showdoublelist(Doublelist *list)
{  
   int value;
   Simplelist *begin;
   Doublelist *aidnext;

   printf("Doublelist: \n");
   while (list)					// while exist a list
     {
	list->GetValue(value);			
	printf(" %d ", value);
	list->GetBegin(begin);
	showsimplelist(begin);			// print content
	list->GetNext(aidnext);			// Goto next
	list = aidnext;
     };
   printf("\n");
};

void testdoublelist()
{
   int i;
   Doublelist *head, *last;
   Simplelist *begin, *end;
   
   begin = new Simplelist(0);
   end = begin;
   begin->InsLast(end, 1); begin->InsLast(end, 2);
   begin->InsLast(end, 3); begin->InsLast(end, 4);
   head = new Doublelist(begin, end);
   last = head;
   for (i=5; i<=20; i=i+5)
     {
	begin = new Simplelist(i);
	end = begin;
   	begin->InsLast(end, i+1); begin->InsLast(end, i+2);
   	begin->InsLast(end, i+3); begin->InsLast(end, i+4);
   	head->InsLast(last, begin, end);
     };
   showdoublelist(head);
   printf("InsFirst\n");
   begin = new Simplelist(-5);
   end = begin;
   begin->InsLast(end, -4); begin->InsLast(end, -3);
   begin->InsLast(end, -2); begin->InsLast(end, -1);
   head->InsFirst(begin, end);
   showdoublelist(head);
   printf("Delnext on head\n"); 
   head->DelNext();
   showdoublelist(head);
   printf("Delfirst on head\n"); 
   head->DelFirst();
   showdoublelist(head);

   printf("Delnext on last\n"); 
   last->DelNext();
   showdoublelist(head);
   printf("Delfirst on last\n"); 
   last->DelFirst();
   showdoublelist(head);
   printf("Delete last with FindBegin of last\n");
   last->GetBegin(begin);
   head->FindBegin(begin, last);
   last->DelNext();
   showdoublelist(head);
   printf("FindValue+DelNext\n"); 
   head->FindValue(2, last);
   last->DelNext();
   showdoublelist(head);
   printf("Find first Value (1) and show empty result\n");
   head->FindValue(1, last);
   showdoublelist(last);
   printf("Find not used Value (12) and show empty result\n");
   head->FindValue(12, last);
   showdoublelist(last);
   printf("Delete\n"); 
   delete head;
   showdoublelist(head);
};

int main()
{
   testsimplelist();
   printf("---------------------\n");
   teststringlist();
   printf("---------------------\n");
   testdoublelist();
   return 0;
};

