/* RandomXmas v1.13 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original
 * Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/
// Joystick nicht getestet !
//
//***Vereinbarungen****************************
//---Includes, Konstanten----------------------

#include <GL/glut.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "spielraum.h"
#include "mann.h"
#include "konstanten.h"
#include "highsboard.h"

//---Typen- und Klassendefiniton----------------
	
typedef enum{angle, trans, reshape} keymodifmodes;
typedef enum{play, anglexy, anglexz, angleyz, transxy, 
		transxz, transyz, scroll} mousemodifmodes;

//--- globale Variablen -----------------------

int		aktangle[3];
float		akttrans[3];
int 		aktwidth, aktheight, menu_id;
keymodifmodes 	modifmodekey;
mousemodifmodes modifmodemouse;
int		joystickx, joysticky, mousex, mousey;
char		*highscorefile=0, *full_name=0;

Spielraum	*spraum;
Mann		*weihmann[MANN_NUMBER], *weihmann_id;		
Highscoreboard  *highscore;

//***Funktionen, OpenGL-Grundlagen***********************

void initVars()
{
  short i;

  for(i = 0; i <= 2; i++) 		// i = X, Y, Z
    { aktangle[i] = 0; akttrans[i] = 0; };
  modifmodekey = angle; modifmodemouse = play;
  aktwidth = ANFWIDTH; aktheight = ANFHEIGHT;
};

void CreateFigure()
{
   int i = 0;

   while( i < MANN_NUMBER )  
	if (weihmann[i])  	i++;		// Find unused
	  else 			break;
   if ( i < MANN_NUMBER )
     {
	weihmann[i] = new Mann(3, 0.6, spraum->GetTexarray());
	weihmann_id = weihmann[i];
     };
};

void SwitchFigure()
{
   int i = 0;

   while( weihmann[i] != weihmann_id )
     i = (i + 1) % MANN_NUMBER;			//Find current
   i = (i + 1) % MANN_NUMBER;			//Goto next
   if (weihmann[i] == NULL) i = 0;		//if not used
   weihmann_id = weihmann[i];
};

void initVarsTwo()
{
  int i;

  spraum = new Spielraum();
  for(i = 0; i < MANN_NUMBER; i++) weihmann[i] = NULL;
  CreateFigure();
};

void InitLight01()
{
   GLfloat pos_light0[] = {0.0, MAXFELDHOEHE*FELDEINHEIT*2, MAXFELD*5, 1.0};
   GLfloat pos_light1[] = {0.0, MAXFELDHOEHE*FELDEINHEIT*2, -MAXFELD*5, 1.0};
 
   glEnable(GL_LIGHT0);
   glLightfv(GL_LIGHT0, GL_POSITION, pos_light0);
   glLightfv(GL_LIGHT0, GL_AMBIENT, PLIGHT_AMB);
   glLightfv(GL_LIGHT0, GL_DIFFUSE, PLIGHT_DIF);
   glLightfv(GL_LIGHT0, GL_SPECULAR, PLIGHT_SPEC);

   glEnable(GL_LIGHT1);
   glLightfv(GL_LIGHT1, GL_POSITION, pos_light1);
   glLightfv(GL_LIGHT1, GL_AMBIENT, PLIGHT_AMB);
   glLightfv(GL_LIGHT1, GL_DIFFUSE, PLIGHT_DIF);
   glLightfv(GL_LIGHT1, GL_SPECULAR, PLIGHT_SPEC);
};

//---Ende + Darstellungsfunktion, greift auf die Klassen zu-------

void endeproc()
{
   int i;

   delete highscore;
   weihmann_id = NULL;
   for(i = 0; i < MANN_NUMBER; i++)
     if (weihmann[i]) delete weihmann[i];
   delete spraum;

   glutDestroyMenu(menu_id);
   exit(0);
}

void InitHighscore()
{
   highscore = new Highscoreboard(spraum->GetPoints(), full_name, 
					highscorefile);
   glutChangeToMenuEntry(1, "Rollen", 70);
   modifmodemouse = scroll;
   glutRemoveMenuItem(5);
   glutRemoveMenuItem(4);
};

void DrawGameScreen()
{
   int i;

   InitLight01();
   glViewport(0, aktheight*4/5, aktwidth, aktheight);
   glMatrixMode(GL_PROJECTION);
   glPushMatrix();
   glLoadIdentity();
   gluPerspective(30, 1, 1, 15*4);
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
   glLoadIdentity();
   gluLookAt(0, 0, 4*3, 0, 0, 0, 0, 1, 0);

   spraum->DrawLevelNum();
   weihmann_id->DrawPunkte();

   glViewport(0, 0, aktwidth, aktheight*4/5);
   glMatrixMode(GL_PROJECTION);
   glPopMatrix();
   glMatrixMode(GL_MODELVIEW);
   glPopMatrix();

   spraum->DrawSpielraum();
   for(i = 0; i < MANN_NUMBER; i++)
     if (weihmann[i]) weihmann[i]->DrawMann();
};

void display(void)
{  
  glEnable(GL_DEPTH_TEST);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix();		
  glTranslatef(akttrans[0]/5, akttrans[1]/5, akttrans[2]/5);
	// X = 0, Y = 1, Z = 2
  if (spraum->GetEnd() == 1) glRotatef(aktangle[0]-24, 1, 0, 0);
			else glRotatef(aktangle[0], 1, 0, 0);
  glRotatef(aktangle[1], 0, 1, 0);
  glRotatef(aktangle[2], 0, 0, 1);

  if (spraum->GetEnd() == 0)
    {
	DrawGameScreen();
    }
  else 
    {
	glViewport(0, 0, aktwidth, aktheight);
	if (spraum->GetEnd() == 1)
	  {
		if (!highscore) InitHighscore();
		highscore->DrawBoard();
	  };
	if (spraum->GetEnd() == 2) endeproc();
    };
  glFlush();
  glPopMatrix();
  glutSwapBuffers();
}

//---Einstellungen fr Darstellung-----------------------------

void DoReshape(int width, int height)
{
   short condition = 0;
   int 	minsize, maxsize;

   aktwidth = width; aktheight = height;
   if (width >= height) { minsize = height; maxsize = width; }
     else { minsize = width; maxsize = height; };
   
   glViewport(0, 0, width, height);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(60*maxsize/minsize, 1, 1, 15*MAXFELD);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   if (spraum) condition = (!spraum->GetViewMann() );
   if ((condition) || (!spraum))
	gluLookAt(0, MAXFELD*7/2, MAXFELD*5, 0, MAXFELD, 0, 0, 1, 0);
};

void init (void)
{  
   glClearColor (0.0, 0.0, 0.0, 0.0);
   glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

   DoReshape(aktwidth, aktheight);

   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, LIGHT_AMB);
   glEnable(GL_LIGHTING);
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, MATERIAL_NULL);
   glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, MATERIAL_NULL);
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, MATERIAL_NULL);
}

void DoRotate(char axis, int addvalue)
//axis: 'x', 'y', 'z'; 'i' for init (initvalue = addvalue)
{
   int i;

   switch (axis) {
     	case 'x' : aktangle[0] = (360 + aktangle[0] + addvalue) % 360; break;
     	case 'y' : aktangle[1] = (360 + aktangle[1] + addvalue) % 360; break;
     	case 'z' : aktangle[2] = (360 + aktangle[2] + addvalue) % 360; break;
	case 'i' : for(i=0; i<=2; i++) aktangle[i] = addvalue; break;
     };
};

void DoTranslation(char axis, float addvalue)
//axis: 'x', 'y', 'z'; 'i' for init (initvalue = addvalue)
{
   int i;

   switch (axis) {
	case 'x' : akttrans[0] = (akttrans[0] + addvalue) ; break;
	case 'y' : akttrans[1] = (akttrans[1] + addvalue) ; break;
	case 'z' : akttrans[2] = (akttrans[2] + addvalue) ; break;
	case 'i' : for(i=0; i<=2; i++) akttrans[i] = addvalue; break;
     };
};

//---Men-Verarbeitung---------------------------------------------------

static void Menufunc(int entry)
{
   switch (entry) {
	case  10 : modifmodemouse = play;		break;
	case 210 : modifmodemouse = anglexy;		break;
	case 220 : modifmodemouse = anglexz;		break;
	case 230 : modifmodemouse = angleyz;		break;
	case 240 : DoRotate('i', 0);			break;
	case 310 : modifmodemouse = transxy;		break;
	case 320 : modifmodemouse = transxz;		break;
	case 330 : modifmodemouse = transyz;		break;
	case 340 : DoTranslation('i', 0);		break;
	case  40 : weihmann_id->TriggerPunktAnz();	break;
	case 510 : spraum->TriggerViewMann();		break;
	case 520 : CreateFigure();			break;
	case 530 : SwitchFigure();			break;
	case  60 : spraum->SwitchEnd(0);		break;
	case  70 : modifmodemouse = scroll;		break;
     };
   glutPostRedisplay();
};

void InitMenu()
{
   int sub_menu_rotate_id, sub_menu_translate_id, sub_menu_mann_id;

   menu_id = glutCreateMenu(Menufunc);
   sub_menu_rotate_id = glutCreateMenu(Menufunc);
   glutAddMenuEntry("Y/X",  210);
   glutAddMenuEntry("Z/X",  220);
   glutAddMenuEntry("Z/Y",  230);
   glutAddMenuEntry("Init", 240);

   sub_menu_translate_id = glutCreateMenu(Menufunc);
   glutAddMenuEntry("X/Y",  310);
   glutAddMenuEntry("X/Z",  320);
   glutAddMenuEntry("Z/Y",  330);
   glutAddMenuEntry("Init", 340);

   sub_menu_mann_id = glutCreateMenu(Menufunc);
   glutAddMenuEntry("Blick", 510);
   glutAddMenuEntry("Neu", 520);
   glutAddMenuEntry("Nchster", 530);

   glutSetMenu(menu_id);
   glutAddMenuEntry("Spielen", 10);
   glutAddSubMenu("Drehen", sub_menu_rotate_id);
   glutAddSubMenu("Verschieben", sub_menu_translate_id);
   glutAddMenuEntry("Punktanzeige", 40);
   glutAddSubMenu("Mann", sub_menu_mann_id);
   glutAddMenuEntry("Beenden", 60);
   glutAttachMenu(GLUT_RIGHT_BUTTON);
};

//---Tastatur/Maus/Joystick-Eingabeverarbeitung--------------------------

void DoMove(short xmove, short ymove, short jump)
{
  int	winkel = 0;

  if (spraum->GetViewMann()) winkel = weihmann_id->GetRichtung();
     else winkel = (360 - aktangle[1]) % 360;			//1 = Y
  if ((winkel <= 45) || (winkel > 315)) winkel = 0;
  else if ((winkel > 45) && (winkel <= 135)) winkel = 90;
  else if ((winkel > 135) && (winkel <= 225)) winkel = 180;
  else if ((winkel > 225) && (winkel <= 315)) winkel = 270;
  if (xmove == -1) winkel = (360 + winkel - 90) % 360;		//Links
  if (xmove ==  1) winkel = (360 + winkel + 90) % 360;		//Rechts
  if (ymove == -1) winkel = (360 + winkel - 180) % 360;		//Unten
  if (ymove ==  1) winkel = winkel;				//Oben
  xmove = 0; ymove = 0;
  if (winkel == 270) xmove = -1;		//Links
  if (winkel ==  90) xmove =  1;		//Rechts
  if (winkel == 180) ymove = -1;		//Unten
  if (winkel ==   0) ymove =  1;		//Oben
  winkel = (360 + winkel - 180) % 360;		//fuer Richtung
  if (jump == 1)
	weihmann_id->AddPos(spraum, 0, 0, 1);
    else {
  		weihmann_id->NeuRichtung(winkel);			
  		weihmann_id->AddPos(spraum, xmove, ymove, 0);
	 };
};

static void joystickfunc(unsigned int buttonMask, int x, int y, int z)
{
  int   movex, movey, sense;

  sense = 5;				// Minimum-Differenz zwischen
					// zweier Mauspunkte zum Bewegen
  movex = x - joystickx;				//Pos-Differenz
  movey = y - joysticky;
  if ( abs(movex) >= abs(movey) ) 
	movey = 0; else movex = 0;			//nicht diagonal
  if (buttonMask & GLUT_JOYSTICK_BUTTON_A)
	DoMove(0, 0, 1);
  if (movex < -sense) DoMove(-1,  0, 0);		//Links
  if (movex >  sense) DoMove( 1,  0, 0);		//Rechts
  if (movey < -sense) DoMove( 0, -1, 0);		//Unten
  if (movey >  sense) DoMove( 0,  1, 0);		//Oben
  joystickx = x; joysticky = y;
  glutPostRedisplay();
}

static void mousefunc(int button, int state, int x, int y)
{
  mousex = x; mousey = y;
  if ((button == GLUT_MIDDLE_BUTTON) && (state == GLUT_DOWN))
	DoMove(0, 0, 1);
}

static void mousemotionfunc(int x, int y)
{
  const int 	anglescale = 5;
  const float	transscale = 20.0f;
  char		axis1, axis2;
  int		movex, movey, sense;

  sense = MOUSE_SENSE;			// Minimum-Differenz zwischen
					// zweier Mauspunkte zum Bewegen
  movex = x - mousex;					//Pos-Differenz
  movey = y - mousey;
  if (modifmodemouse == play)
    {
	if (abs(movex) >= abs(movey)) 
		movey = 0; else movex = 0;		//nicht diagonal
  	if (movex < -sense) DoMove(-1,  0, 0); 		//Links
  	if (movex >  sense) DoMove( 1,  0, 0); 		//Rechts
  	if (movey < -sense) DoMove( 0, -1, 0);		//Unten
  	if (movey >  sense) DoMove( 0,  1, 0);		//Oben
    };
  axis1 = 'a'; axis2 = 'b';				// Zero-Values
  if (modifmodemouse == anglexy) { axis1 = 'y'; axis2 = 'x'; };
  if (modifmodemouse == anglexz) { axis1 = 'z'; axis2 = 'x'; };
  if (modifmodemouse == angleyz) { axis1 = 'z'; axis2 = 'y'; };
  if (axis1 == 'z') movex = -movex;
  DoRotate(axis1, movex / anglescale); 
  DoRotate(axis2, movey / anglescale);
  axis1 = 'a'; axis2 = 'b';				// Zero-Values
  if (modifmodemouse == transxy) { axis1 = 'x'; axis2 = 'y'; };
  if (modifmodemouse == transxz) { axis1 = 'x'; axis2 = 'z'; };
  if (modifmodemouse == transyz) { axis1 = 'z'; axis2 = 'y'; };
  if (axis2 == 'y') movey = -movey;
  DoTranslation(axis1, movex / transscale); 
  DoTranslation(axis2, movey / transscale);
  if (modifmodemouse == scroll) highscore->Scroll(movey / 10);
  if ((abs(movex) > sense) || (abs(movey) > sense))
  	{ mousex = x; mousey = y; };
  glutPostRedisplay();
}

static void mousepassivefunc(int x, int y)
{
  mousex = x; mousey = y;
};

static void specialkey(int key, int x, int y)
{
  switch (key) {
     case GLUT_KEY_END	 : DoMove( 0,  0, 1); break;
     case GLUT_KEY_LEFT  : DoMove(-1,  0, 0); break;
     case GLUT_KEY_RIGHT : DoMove( 1,  0, 0); break;
     case GLUT_KEY_UP    : DoMove( 0, -1, 0); break;
     case GLUT_KEY_DOWN  : DoMove( 0,  1, 0); break;
     case GLUT_KEY_PAGE_UP : if (highscore) highscore->Scroll(-1); break;
     case GLUT_KEY_PAGE_DOWN : if (highscore) highscore->Scroll(+1); break;
     }
   glutPostRedisplay();
}

static void key(unsigned char k, int x, int y)
{
  short mult;

  switch (k) {
     case 'v' : modifmodekey = trans; 		break;
     case 'd' : modifmodekey = angle; 		break;
     case 'n' : CreateFigure();			break;
     case 'r' : modifmodekey = reshape; 	break;
     case 's' : SwitchFigure();			break;
     case 'p' : weihmann_id->TriggerPunktAnz(); break;
     case 'b' : spraum->TriggerViewMann(); 	break;
     case 27  : spraum->SwitchEnd(0); 		break;
     }
  if ( isupper(k) ) mult = -1; else mult = 1;
  k = tolower(k);
  if (k == 'i') mult = 0;
  if (modifmodekey == angle) DoRotate(k, mult * 30);
  if (modifmodekey == trans) DoTranslation(k, mult * 1);
  if (modifmodekey == reshape)
    switch (k) {
     case 'x' : if (aktwidth > -10*mult) 
			aktwidth = (aktwidth + mult*10); break;
     case 'y' : if (aktheight > -10*mult) 
			aktheight = (aktheight + mult*10); break; 
     case 'i' : aktwidth = ANFWIDTH; aktheight = ANFHEIGHT; break;
    }  
  if (reshape) glutReshapeWindow(aktwidth, aktheight);
  glutPostRedisplay();
}

//---Hauptprogramm---------------------------------------------

int main(int argc, char** argv)
{
   short laenge=0;
   char  *vorname=0, *nachname=0;

   if (argc >= 1) highscorefile = argv[1];
   if (argc >= 2) vorname = argv[2];
   if (argc >= 3) nachname = argv[3]; else nachname = "RandomXmas 1.13";
   if (vorname) laenge = strlen(vorname);
   if (nachname) laenge = laenge + strlen(nachname) + 1;
   full_name = new char[ laenge ];
   if (vorname) 
	{ strcat(full_name, vorname); strcat(full_name, " "); };
   if (nachname) strcat(full_name, nachname);
   initVars();

   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
   glutInitWindowPosition (100, 100);
   glutCreateWindow ("spiel");
   init();
   InitMenu();
   initVarsTwo();

   glutDisplayFunc(display);
   glutReshapeFunc(DoReshape);
   glutKeyboardFunc(key);
   glutSpecialFunc(specialkey);
   glutJoystickFunc(joystickfunc, 10);
   glutMouseFunc(mousefunc);
   glutMotionFunc(mousemotionfunc);
   glutPassiveMotionFunc(mousepassivefunc);
   glutReshapeWindow(aktwidth, aktheight);

   glutMainLoop();

   return 0; 
}

