/* Teil von RandomXmas v1.13 zu Weihnachten 2001 
 * Frei kopierbar, aber nur vollstndig mit diesem Spiel.cpp und Makefile und 
 * readme.txt. Vernderungen mglich, bei Weitergabe aber immer Original 
 * hiervon und Spiel.cpp mit beilegen,		
 * Keine Patentierungen auf Teile des oder ganzes Programm(s)*/

#include <stdio.h>

#include "spielraum.h"

void Spielraum::InitTextur(const char* texfile, Texture* &thistex)
{
  short   usable;
  FILE	  *fpr;

  thistex = NULL;
  fpr = fopen(texfile, "r");
  if (fpr) usable = 1;
    else   usable = 0;
  if (fpr) fclose(fpr);
  if (usable)  
   {
	thistex = new Texture(0.0, 0.0, 0.0);
	thistex->Readbmp(texfile);
   };
};

Spielraum::Spielraum()
{
  int i;

  currentlevel = 1; points = 0; end = 0; viewmann = 0;
  for(i=0; i<NUMOFTEX; i++) texarray[i] = NULL;
  if (USE_TEXTURES)
    {
	InitTextur(FILETEXEBENE,   texarray[0]);
	InitTextur(FILETEXHUEGEL,  texarray[1]);
	InitTextur(FILETEXBAUM,    texarray[2]);
	InitTextur(FILETEXCAP,     texarray[3]);
	InitTextur(FILETEXHEAD,    texarray[4]);
	InitTextur(FILETEXBODY,    texarray[5]);
	InitTextur(FILETEXSHOES,   texarray[6]);
    };
  for(i=0; i < MAXEBENEN-2; i++)
    {
	levels[i] = NULL;
	usedlevels[i] = 0;
    };
  levels[currentlevel - 1] = new Ebene(currentlevel-1, texarray);
  usedlevels[currentlevel - 1 ] = 1;
};

Spielraum::~Spielraum()
{
   int i;

   for(i=0; i < MAXEBENEN-2; i++)
     {
	if ( levels[i] ) delete levels[i];
	usedlevels[i] = 0;
     };
   for(i=0; i < NUMOFTEX; i++)
   	if (texarray[i]) delete texarray[i];
};

short Spielraum::SwitchLevel(int nextlevel)
{
   int lastlevel;

   if (currentlevel == nextlevel) 
     if (currentlevel+1 < MAXEBENEN) nextlevel++;
       else nextlevel--;
   if ((nextlevel > 0) && (nextlevel < MAXEBENEN-1))
     {
	levels[currentlevel-1]->TrigFahrstuhl();	//Switch off
	if (!(usedlevels[nextlevel-1]))
	  {
	   	levels[nextlevel-1] = new Ebene(nextlevel-1, texarray);
	  	usedlevels[nextlevel-1] = 1;
	  }
	  else levels[nextlevel-1]->TrigFahrstuhl();	//Switch On
						
	lastlevel = currentlevel;			//Change
	currentlevel = nextlevel;
     };
   return (currentlevel != lastlevel);
};

int Spielraum::GetContent(int neuposx, int neuposy)
{
   return levels[currentlevel-1]->IstDortBaum(neuposx, neuposy);
};

int Spielraum::GetAbove(int neuposx, int neuposy)
{
   return levels[currentlevel-1]->GetDarueber(neuposx, neuposy);
};

int Spielraum::GetEnd()
{
   return end;
};

int Spielraum::SwitchEnd(int newpoints)
{
   end = end + 1;
   if (viewmann) TriggerViewMann();
   if (end == 1) points = newpoints;	// else not useful
   return end;
};

int Spielraum::GetPoints()
{
   return points;
};

int Spielraum::GetViewMann()
{
   return viewmann;
};

int Spielraum::TriggerViewMann()
{
   if (viewmann)
	  {
		viewmann = 0;
		glLoadIdentity();
		gluLookAt(0, MAXFELD*7/2, MAXFELD*5,
			  0, MAXFELD, 0, 0, 1, 0);
	  }
  else viewmann = 1;
  return viewmann;
};

Texture** Spielraum::GetTexarray()
{
   return texarray;
};

void Spielraum::DrawSpielraum()
{
  	levels[currentlevel-1]->DrawEbene();
};

void Spielraum::DrawLevelNum()
{
  	levels[currentlevel-1]->DrawLevelNum();
};

